﻿using System;

namespace Client
{
    internal class Program
    {
        public static async Task Main(string[] args)
        {
            var client = new HttpClient()
            {
                BaseAddress = new Uri("http://localhost:58118")
            };

            Console.WriteLine("Press any key to make an HTTP Request.  'q' to quit.");

            while (Console.ReadKey() != new ConsoleKeyInfo('q', ConsoleKey.Q, false, false, false))
            {
                var guid = Guid.NewGuid();
                Console.WriteLine(guid);

                using (var message = new HttpRequestMessage(HttpMethod.Post, $"/message/{guid}"))
                {
                    var result = await client.SendAsync(message, HttpCompletionOption.ResponseHeadersRead);
                    Console.WriteLine($"{result.IsSuccessStatusCode} {(int)result.StatusCode}:{result.StatusCode}");
                }
            }
        }
    }
}