﻿using System;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using NServiceBus.TransactionalSession;

[ApiController]
[Route("")]
public class SendMessageController : Controller
{
    readonly ITransactionalSession messageSession;
    readonly MyDataContext dataContext;

    public SendMessageController(ITransactionalSession messageSession, MyDataContext dataContext)
    {
        this.messageSession = messageSession;
        this.dataContext = dataContext;
    }

    #region txsession-controller
    [HttpPost("message/{guid}")]
    [ProducesResponseType(StatusCodes.Status201Created)]
    public async Task<IActionResult> Get([FromRoute] Guid guid)
    {
        var id = guid.ToString();

        var myEntity = new MyEntity { Id = id, Processed = false };
        await dataContext.MyEntities.AddAsync(myEntity);

        var message = new MyMessage { EntityId = id };
        messageSession.SendLocal(message).Wait();

        return CreatedAtAction(nameof(SendMessageController.Get), message);
    }
    #endregion
}
